leetcode 568. Maximum Vacation Days

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

 

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation: 
Ans = 6 + 3 + 3 = 12. 

One of the best strategies is:
1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day. 
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 
2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days.
3rd week : stay at city 2, and play 3 days and work 4 days.

 

Example 2:

Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation: 
Ans = 1 + 1 + 1 = 3. 

Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks. 
For each week, you only have one day to play and six days to work. 
So the maximum number of vacation days is 3.

 

Example 3:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21

One of the best strategies is:
1st week : stay at city 0, and play 7 days. 
2nd week : fly from city 0 to city 1 on Monday, and play 7 days.
3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

 

Note:

  1. N and K are positive integers, which are in the range of [1, 100].
  2. In the matrix flights, all the values are integers in the range of [0, 1].
  3. In the matrix days, all the values are integers in the range [0, 7].
  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
  6. We don't consider the impact of flight hours towards the calculation of vacation days.

解答思路:

這道題其實跟之前“Paint Houses Ⅱ”有類似之處,但這道題目前我還沒想到將其優化爲O(K * N )的方法 , 目前這個方法時間複雜度爲O(K * N * N)。 不同的地方在於對於每一個城市,航班可達的其他城市都不一樣;

思路如下:

假設第k個星期是在城市j度過,那麼最大可度假天數設爲dp[k][j] ;

dp[k][j] = max(dp[k][i]) + days[j][k -1] ; (對所有 i 滿足 flights[i][j] != 0) //dp[k][j] 爲 -1時表示第k個星期無法在城市j度過

class Solution {
public:
    int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) 
    {
        if(flights.empty() || days[0].empty()) return 0 ;
        
        int citys = flights.size() , weeks = days[0].size() ;
        vector<int> dp( citys , -1) ;
        dp[0] = 0 ;
        
        for(int week = 1 ; week <= weeks ; week++)
        {
            
            vector<int> prev_dp = dp ;
            for(int city = 0 ; city < citys ; city++)
            {
                dp[city] = -1 ;
                for(int prev_city = 0 ; prev_city < citys ; prev_city++)
                {
                    if(prev_dp[prev_city] == -1 || (prev_city != city && flights[prev_city][city] == 0)) continue ;
                    dp[city] = max(dp[city] , prev_dp[prev_city]) ;
                }
                
                dp[city] += (dp[city] == -1 ? 0 : days[city][week - 1]) ;
            }
        }
        
        int res = 0 ;
        for(auto days : dp)
        {
            if(days != -1) res = max(res , days) ;
        }
        
        return res ;
    }
};

 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章